#include <imsls.h>
#include <stdio.h>
int main()
{
   float pvalue = -99.;
   int n_levels[] = {4, 4, 2};
   int indrf[] = {2, 3};
   int nfef[] = {1, 1, 2};
   int indef[] = {1, 2, 1, 2};
   float y[] = {3.0, 6.0, 3.0, 1.0, 2.0, 2.0, 3.0, 2.0, 4.0, 5.0, 
      4.0, 2.0, 3.0, 4.0, 3.0, 3.0, 7.0, 8.0, 7.0, 5.0, 6.0, 5.0,
      6.0, 6.0, 7.0, 8.0, 9.0, 10.0, 10.0, 9.0, 8.0, 11.0
   };
   float *aov, *y_means, *variance_components, *ems;

   char    *aov_labels[] = {
      "degrees of freedom for model", "degrees of freedom for error",
      "total (corrected) degrees of freedom", 
      "sum of squares for model", "sum of squares for error", 
      "total (corrected) sum of squares", "model mean square", 
      "error mean square", "F-statistic", "p-value", 
      "R-squared (in percent)", "adjusted R-squared (in percent)",
      "est. standard deviation of within error", "overall mean of y",
      "coefficient of variation (in percent)"
   };
   char    *ems_labels[] = {
      "Effect A and Error", "Effect A and Effect AB", 
      "Effect A and Effect B", "Effect A and Effect A",
      "Effect B and Error", "Effect B and Effect AB", 
      "Effect B and Effect B", "Effect AB and Error", 
      "Effect AB and Effect AB", "Error and Error"
   };
   char    *means_labels[] = {
      "Grand mean",   
      " A means 1",   " A means 2",   " A means 3",   " A means 4",
      " B means 1",   " B means 2",   " B means 3",   " B means 4",   
      "AB means 1 1", "AB means 1 2", "AB means 1 3", "AB means 1 4", 
      "AB means 2 1", "AB means 2 2", "AB means 2 3", "AB means 2 4", 
      "AB means 3 1", "AB means 3 2", "AB means 3 3", "AB means 3 4", 
      "AB means 4 1", "AB means 4 2", "AB means 4 3", "AB means 4 4"
   };
   char    *components_labels[] = {
      "degrees of freedom for A", "sum of squares for A", 
      "mean square of A", "F-statistic for A", "p-value for A",
      "Estimate of A", "Percent Variation Explained by A",
      "95% Confidence Interval Lower Limit for A",
      "95% Confidence Interval Upper Limit for A", 
      "degrees of freedom for B", "sum of squares for B",
      "mean square of B", "F-statistic for B", "p-value for B",
      "Estimate of B", "Percent Variation Explained by B",
      "95% Confidence Interval Lower Limit for B",
      "95% Confidence Interval Upper Limit for B",
      "degrees of freedom for AB", "sum of squares for AB",
      "mean square of AB", "F-statistic for AB", "p-value for AB",
      "Estimate of AB", "Percent Variation Explained by AB",
      "95% Confidence Interval Lower Limit for AB",
      "95% Confidence Interval Upper Limit for AB",
      "degrees of freedom for Error", "sum of squares for Error",
      "mean square of Error", "F-statistic for Error", 
      "p-value for Error", "Estimate of Error", 
      "Percent Explained by Error",
      "95% Confidence Interval Lower Limit for Error",
      "95% Confidence Interval Upper Limit for Error"
   };

   pvalue = imsls_f_anova_balanced(3, n_levels, y, 2, indrf, 3, 
      nfef, indef, 
      IMSLS_MODEL, 1, 
      IMSLS_EMS, &ems, 
      IMSLS_VARIANCE_COMPONENTS, &variance_components,
      IMSLS_Y_MEANS, &y_means,
      IMSLS_ANOVA_TABLE, &aov,
      0);

   printf("p value of F statistic = %f\n", pvalue);
   imsls_f_write_matrix("* * * Analysis of Variance * * *", 15, 1, aov, 
      IMSLS_ROW_LABELS, aov_labels,
      IMSLS_WRITE_FORMAT, "%10.5f",
      0); 
   imsls_f_write_matrix(
      "* * * Expected Mean Square Coefficients * * *", 
      10, 1, ems,
      IMSLS_ROW_LABELS, ems_labels,  
      IMSLS_WRITE_FORMAT, "%6.2f", 
      0);  
   imsls_f_write_matrix(
      "* * Analysis of Variance / Variance Components * *",
      36, 1,
      variance_components,
      IMSLS_ROW_LABELS, components_labels,
      IMSLS_WRITE_FORMAT, "%10.5f",
      0);
   imsls_f_write_matrix("means", 25, 1, y_means,  
      IMSLS_ROW_LABELS, means_labels,
      IMSLS_WRITE_FORMAT, "%6.2f",
      0);

}